//+------------------------------------------------------------------+
//|                                       historically predicted ATR |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern int  AtrPeriod = 14;
extern bool Center    = true;

double atr[];
int    halfPeriod;
int    displace;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,atr);
      AtrPeriod  = MathMax(AtrPeriod,1);
      halfPeriod = MathCeil(AtrPeriod/2.0);
      displace   = PERIOD_D1/Period();
   IndicatorShortName("Historically predicted ATR ("+AtrPeriod+")");
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (Period()>PERIOD_H1) return(0);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      int bar = i+displace;
      if (Center)
            { if (bar>=halfPeriod) atr[i] = iATR(NULL,0,AtrPeriod,bar-halfPeriod); }
      else  { if (bar>=AtrPeriod)  atr[i] = iATR(NULL,0,AtrPeriod,bar-AtrPeriod);  }
   }
   return(0);
}